
#include <stdio.h>
#include <errno.h>
#include <string.h>
#include <vector>

#define DEBUG_BINDING

#include "Matmul.h"
#include "Matrix.h"
#include "Block.h"

int N;  //MSIZE
int M;	//BSIZE
double val;

int main(int argc, char **argv)
{
	Matrix A;
	Matrix B;
	Matrix C;

	if (argc < 2) {
		//TODO: usage
	} else {

		N = atoi(argv[1]);
		M = atoi(argv[2]);
		val = atof(argv[3]);

		compss_on();

		cout << "Running with the following parameters:\n";
		cout << " - N: " << N << "\n";
		cout << " - M: " << M << "\n";
		cout << " - val: " << val << "\n";

		//initMatrix(&A,N,M,val);
		A = Matrix::init(N,M,val);

		initMatrix(&B,N,M,val);
		initMatrix(&C,N,M,0.0);

		cout << "Waiting for initialization...\n";


		// compss_wait_on(A);
		compss_wait_on(B);
		compss_wait_on(C);


		cout << "Initialization ends...\n";

		C.multiply(A, B);

		compss_off();

		if ((N <= 10) && (M <= 10)) {
			cout << "Matrix A\n";
			A.print();
			cout << "Matrix B\n";
			B.print();
			cout << "Matrix C\n";
			C.print();
		}

	}

	return 0;
}
