
#ifndef BLOCK_H
#define BLOCK_H

#include <vector>
#include <boost/archive/text_iarchive.hpp>
#include <boost/archive/text_oarchive.hpp>
#include <boost/serialization/serialization.hpp>
#include <boost/serialization/access.hpp>
#include <boost/serialization/vector.hpp>

using namespace std;
using namespace boost;
using namespace serialization;

class Block {

public:
	Block(){};

	Block(int bSize);

	static Block *init(int bSize, double initVal);

	void multiply(Block block1, Block block2);

	void print();

private:
	int M;
	std::vector< std::vector< double > > data;

	friend class::serialization::access;
	template<class Archive>
	void serialize(Archive & ar, const unsigned int version) {
		ar & M;
		ar & data;
	}
};

#endif
