
#include <GS_templates.h>

#include "Matrix.h"

Matrix::Matrix(int mSize) {
	N = mSize;
	data.resize(N);
	for (int i=0; i<N; i++) {
		data[i].resize(N);
	}
}

#ifdef COMPSS_WORKER

Matrix Matrix::init(int mSize, int bSize, double val) {
	Matrix matrix(mSize);
	for (int i=0; i<mSize; i++) {
		for (int j=0; j<mSize; j++) {
			matrix.data[i][j] = Block::init(bSize, val);
		}
	}
	return matrix;
}

#endif

void Matrix::multiply(Matrix matrix1, Matrix matrix2) {
	for (int i=0; i<N; i++) {
		for (int j=0; j<N; j++) {

			for (int k=0; k<N; k++) {
				data[i][j]->multiply(*matrix1.data[i][k], *matrix2.data[k][j]);
				//multiplyBlocks(data[i][j], matrix1.data[i][k], matrix2.data[k][j]);
			}

		}
	}

	for (int i=0; i<N; i++) {
		for (int j=0; j<N; j++) {

			compss_wait_on(*data[i][j]);

		}
	}

}

void Matrix::print() {
	for (int i=0; i<N; i++) {
		for (int j=0; j<N; j++) {
			data[i][j]->print();
			cout << "\r\n";
		}
		cout << "\r\n";
	}
}

#ifdef COMPSS_WORKER

void initMatrix(Matrix *matrix, int mSize, int nSize, double val) {
	*matrix = Matrix::init(mSize, nSize, val);
}

void multiplyBlocks(Block *block1, Block *block2, Block *block3) {
	block1->multiply(*block2, *block3);
}

/*
#else

extern void initMatrix(Matrix *matrix, int mSize, int nSize, double val);
extern void multiplyBlocks(Block *block1, Block *block2, Block *block3);
*/
#endif

